/*
 * proto.h -- prototypes for library functions.
 */

/*
 * The following code is operating-system dependent. [@proto.01].
 *  Prototypes for library functions.
 */

#if PORT
#endif					/* PORT */

#if AMIGA
#if LATTICE
#include <dos.h>
#endif					/* LATTICE */
/* ****  TEMPORARY *** */
novalue	_exit		Params((int));
novalue	abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
pointer	calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue	exit		Params((int));
char	*getenv		Params((char *));
char	*getmem		Params((unsigned));
pointer	malloc		Params((msize));
pointer	realloc		Params((pointer, unsigned));
char	*strchr		Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy		Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp		Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#endif					/* ATARI_ST */

#if HIGHC_386
/* ****  TEMPORARY *** */
novalue	_exit		Params((int));
novalue	abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
pointer	calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue	exit		Params((int));
char	*getenv		Params((char *));
char	*getmem		Params((unsigned));
pointer	malloc		Params((msize));
pointer	realloc		Params((pointer, unsigned));
char	*strchr		Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy		Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp		Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#endif					/* HIGHC_386 */

#if MACINTOSH
#if MPW
#include <stdlib.h>
#include <string.h>
#else					/* MPW */
/* ****  TEMPORARY *** */
novalue	_exit		Params((int));
novalue	abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
pointer	calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue	exit		Params((int));
char	*getenv		Params((char *));
char	*getmem		Params((unsigned));
pointer	malloc		Params((msize));
pointer	realloc		Params((pointer, unsigned));
char	*strchr		Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy		Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp		Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#endif					/* MPW */
#endif					/* MACINTOSH */

#if MSDOS
#include <dos.h>
/* ****  TEMPORARY *** */
novalue	_exit		Params((int));
novalue	abort		Params((noargs));
long	atol		Params((char *));
pointer	calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue	exit		Params((int));
char	*getenv		Params((char *));
char	*getmem		Params((unsigned));
pointer	malloc		Params((msize));
pointer	realloc		Params((pointer, unsigned));
char	*strchr		Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy		Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp		Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#endif					/* MSDOS */

#if OS2
#include <dos.h>
/* ****  TEMPORARY *** */
novalue _exit		Params((int));
novalue abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
pointer calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue exit		Params((int));
char	*getenv 	Params((char *));
char	*getmem 	Params((unsigned));
pointer malloc		Params((msize));
pointer realloc 	Params((pointer, unsigned));
char	*strchr 	Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy 	Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp 	Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#endif					/* OS2 */

#if UNIX
#ifndef NoUnixProtos
#ifndef CRAY
novalue	_exit		Params((int));
novalue	abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
char	*getenv		Params((char *));
pointer	calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue	exit		Params((int));
char	*getmem		Params((unsigned));
pointer	malloc		Params((msize));
pointer	realloc		Params((pointer, unsigned));
char	*strchr		Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy		Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp		Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#else					/* CRAY */
#include <stdlib.h>
#include <string.h>
#endif					/* CRAY */
#endif					/* NoUnixProtos */
#endif					/* UNIX */

#if VM || MVS
/* ****  TEMPORARY *** */
novalue _exit           Params((double,int));  /* to cause trouble */
novalue abort           Params((noargs));
double  atof            Params((char *));
long    atol            Params((char *));
pointer calloc          Params((unsigned,unsigned));
int     execv           Params((double,char *, char **));
int     execvp          Params((double,char *, char **));
novalue exit            Params((int));
char    *getenv         Params((char *));
char    *getmem         Params((double,unsigned));
pointer malloc          Params((msize));
pointer realloc         Params((pointer, unsigned));
#ifdef StandardC
#include <string.h>
#else					/* StandardC */
char    *strchr         Params((char *s, int i));
int     strcmp          Params((char *s1, char *s2));
char    *strcpy         Params((char *s1, char *s2));
char    *strncat        Params((char *s1, char *s2, int n));
int     strncmp         Params((char *s1, char *s2, int n));
char    *strncpy        Params((char *s1, char *s2, int n));
#endif					/* StandardC */
#endif					/* VM || MVS */

#if VMS
/* ****  TEMPORARY *** */
novalue	_exit		Params((int));
novalue	abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
pointer	calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue	exit		Params((int));
char	*getenv		Params((char *));
char	*getmem		Params((unsigned));
pointer	malloc		Params((msize));
pointer	realloc		Params((pointer, unsigned));
char	*strchr		Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy		Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp		Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#endif					/* VMS */

/*
 * End of operating-system specific code.
 */

#ifdef KeyboardFncs
int	getch		Params((noargs));
int	getche		Params((noargs));
int	kbhit		Params((noargs));
#endif					/* KeyboardFncs */

#ifdef SystemFncs
int	system		Params((char *));
#endif					/* SystemFncs */

#include "..\common\cproto.h"
